import math
import threading
import time
from fischertechnik.controller.Motor import Motor
from lib.controller import *
from lib.display import *
from lib.line import *

started = None
success = None


def thread_display_update():
    global started, success
    display.set_attr("txt_button_start.enabled", str(True).lower())
    while True:
        display.set_attr("txt_label_line.text", str('<b>{}</b> | {:.0f} | <b>{}</b>'.format(get_i1(), get_line(), get_i2())))
        display.set_attr("txt_slider_line.value", str(round(get_line())))
        display.set_attr("txt_status_indicator_end.active", str(is_endline()).lower())
        display.set_attr("txt_status_indicator_white.active", str(is_white()).lower())
        time.sleep(0.2)


def on_txt_button_start_clicked(event):
    global started, success
    started = True


display.button_clicked("txt_button_start", on_txt_button_start_clicked)


started = False
init_calib_sensors()
threading.Thread(target=thread_display_update, daemon=True).start()
while True:
    if started:
        break
    time.sleep(0.010)
calib_line_rotate360()
while True:
    read_line_sensors()
    if False:
        print_line_info()
    if is_endline():
        TXT_M_M1_encodermotor.set_speed(int(512), Motor.CCW)
        TXT_M_M2_encodermotor.set_speed(int(512), Motor.CW)
        TXT_M_M1_encodermotor.set_distance(int(161), TXT_M_M2_encodermotor)
        while True:
            if (not TXT_M_M1_encodermotor.is_running()):
                break
            time.sleep(0.010)
    elif is_white():
        if True:
            TXT_M_M1_encodermotor.set_speed(int(512), Motor.CCW)
            TXT_M_M2_encodermotor.set_speed(int(512), Motor.CW)
            TXT_M_M1_encodermotor.set_distance(int(161), TXT_M_M2_encodermotor)
            while True:
                if (not TXT_M_M1_encodermotor.is_running()):
                    break
                time.sleep(0.010)
            TXT_M_M1_encodermotor.stop_sync(TXT_M_M2_encodermotor)
            started = False
            while True:
                if started:
                    break
                time.sleep(0.010)
        else:
            TXT_M_M1_encodermotor.set_speed(int(512), Motor.CCW)
            TXT_M_M2_encodermotor.set_speed(int(512), Motor.CW)
            TXT_M_M1_encodermotor.set_distance(int(161), TXT_M_M2_encodermotor)
            while True:
                if (not TXT_M_M1_encodermotor.is_running()):
                    break
                time.sleep(0.010)
    else:
        success = follow_line_step(512, 500)


